<template>
	<mind-form v-model="formViaje" title="Despachar Viaje"
		@submit="onSubmitViaje" hide-buttons :rules="rules"
		>
			<template v-slot="{form}">			
				<el-row>
					<el-col  :lg="12" >
						<el-form-item  label="Origen">
							<b>{{form.origenCalle}} {{form.origenNumero}}</b>
						</el-form-item>
					</el-col>
					<el-col v-if="form.origenCalle1 && form.origenCalle2" :lg="12" >
						<el-form-item  label="Entre">
							<b>{{form.origenCalle1}} y {{form.origenCalle2}}</b>
						</el-form-item>
					</el-col>
					<el-col v-else-if="form.origenCalle1" :lg="12" >
						<el-form-item  label="Esquina">
							<b>{{form.origenCalle1}}</b>
						</el-form-item>
					</el-col>
				</el-row>
				<el-row>
					<el-col  :lg="12" >
						<el-form-item  label="Destino">
							<b>{{form.destinoCalle}} {{form.destinoNumero}}</b>
						</el-form-item>
					</el-col>
					<el-col  :lg="24" >
						<el-form-item  label="Notas">
							<b>{{form.obs}}</b>
						</el-form-item>
					</el-col>
					<el-col  :lg="24" >
						<el-form-item label="Móvil" prop="idPlanilla">
							<el-select v-model="form.idPlanilla"  >
								<el-option-group label="Libres">
									<el-option
										style="color: #67C23A;"
										v-for="item in movilesLibres"
										:key="item.id"
										:label="item.movil"
										:value="item.id">
											<span style="float: left">{{ item.movil }}</span>
											<!-- <span style="float: right; color: #8492a6; font-size: 13px">{{ item.estadoMovil }}</span> -->
										</el-option>
								</el-option-group>
								<el-option-group label="Ocupados">
									<el-option
										style="color: #F56C6C98;"
										v-for="item in movilesOcupados"
										:key="item.id"
										:label="item.movil"
										:value="item.id">
											<span style="float: left">{{ item.movil }}</span>
											<!-- <span style="float: right; color: #8492a6; font-size: 13px">{{ item.estadoMovil }}</span> -->
										</el-option>
								</el-option-group>
							</el-select>
							<!-- <el-input v-model="form.idPlanilla" placeholder="Móvil"/> -->
						</el-form-item>
					</el-col>
				</el-row>
			</template>
			<template  v-slot:footer="{submit}" >
				<el-button type="primary" @click="submit()">Despachar</el-button>
			</template>
	</mind-form>
</template>
<script>
import store from '@/store/viajes'
import planillas from '@/store/planillas'
import {Rest, Rules} from '@/../modules/mind-core-vue/'
export default {
	props: {
		idViaje: [Number, String],
		idPlanilla: [Number, String],
	},
	computed: {
		movilesLibres() {
			return planillas.data.RESOURCE_LIST.filter((v)=>{
				return v.estadoMovil == "Libre"
			})
		},
		movilesOcupados() {
			return planillas.data.RESOURCE_LIST.filter((v)=>{
				return v.estadoMovil == "Ocupado"
			})		}
	},
	methods: {
		/**
		 * Obtiene los datos del viaje seleccionado
		 * @param id id de viaje
		 */
		async fetchViaje(id) {
			this.formViaje = await this.api.Fetch(id).catch((error)=>{
				this.$message({
					showClose: true,
					type: 'error',
					message: error
				});				
			})
			this.formViaje.idPlanilla = this.idPlanilla
		},


		/**
		 * Actualiza viaje
		 * @param viaje datos del viaje
		 */
		async onSubmitViaje(viaje) {
			const now = new Date()
			const fecha = `${now.getFullYear()}-${now.getMonth()+1}-${now.getDate()}`
			const hora = `${now.getHours()}:${now.getMinutes()<10 ? '0'+ now.getMinutes(): now.getMinutes()}`
			let result, msg ;
			if(!viaje.idPlanilla) {
				result = 'error'
				msg = 'No se asignó un Móvil al viaje'
			}	else if(viaje.id) { //viaje Existente
				const data = {
					id: viaje.id,
					idPlanilla: viaje.idPlanilla,
					estado: 'En Curso',
					fecha: fecha,
					horaSalida: hora,
				}
				await this.api.Patch(data)
				.then(()=>{
					result = 'success'
					msg = 'Viaje despachado correctamente'
				})
				.catch((error)=> {
					result = 'error'
					msg = error
				})
				this.$emit('submit',data)
			} 
			this.$message({
				type: result,
				showClose: result == 'error',
				message: msg
			});
		},
	},
	watch: {
		idViaje: {
			immediate: true,
			handler(v) {
				this.api = new Rest({
					uri: `api/agencias/${store.idAgencia}/viajes`, 
					state: store.data,
					key: 'id'})
				if(v) {
					this.fetchViaje(v)
				} 
			}
		},
	},
	data() {
		return {
			formViaje: {},
			rules: {
				idPlanilla:[
					Rules.required
				]
			}
		}
	}

}
</script>
<style scoped>
.el-divider {
	margin: 10px 0px;
}

</style>
